"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var React=require("react"),React__default=_interopDefault(React),reactDom=require("react-dom");require("prop-types");var invariant=_interopDefault(require("invariant"));function _defaults2(e,t){for(var n=Object.getOwnPropertyNames(t),i=0;i<n.length;i++){var r=n[i],a=Object.getOwnPropertyDescriptor(t,r);a&&a.configurable&&void 0===e[r]&&Object.defineProperty(e,r,a)}return e}function _extends(){return(_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(e[i]=n[i])}return e}).apply(this,arguments)}function _inheritsLoose(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,_defaults2(e,t)}function _objectWithoutPropertiesLoose(e,t){if(null==e)return{};var n,i,r={},a=Object.keys(e);for(i=0;i<a.length;i++)n=a[i],t.indexOf(n)>=0||(r[n]=e[n]);return r}function defer(e){return requestAnimationFrame(e)}function cancelDefer(e){cancelAnimationFrame(e)}function setInputSelection(e,t,n){void 0===n&&(n=t),e.setSelectionRange(t,n)}function getInputSelection(e){var t=e.selectionStart,n=e.selectionEnd;return{start:t,end:n,length:n-t}}function isInputFocused(e){return document.hasFocus()&&document.activeElement===e}function useInputElement(e){return React.useCallback(function(){var t=e.current,n="undefined"!=typeof window&&t instanceof window.HTMLElement;if(!t||!n)return null;if("INPUT"!==t.nodeName&&(t=t.querySelector("input")),!t)throw new Error("react-input-mask: inputComponent doesn't contain input node");return t},[e])}function useDeferLoop(e){var t=React.useRef(null),n=React.useCallback(function(){null===t.current&&function n(){e(),t.current=defer(n)}()},[e]),i=React.useCallback(function(){cancelDefer(t.current),t.current=null},[]);return React.useEffect(function(){t.current&&(i(),n())},[n,i]),React.useEffect(cancelDefer,[]),[n,i]}function useSelection(e,t){var n=React.useRef({start:null,end:null}),i=useInputElement(e),r=React.useCallback(function(){return getInputSelection(i())},[i]),a=React.useCallback(function(){return n.current},[]),o=React.useCallback(function(e){var t=i();t&&isInputFocused(t)&&(setInputSelection(t,e.start,e.end),n.current=r())},[i,r]),u=useDeferLoop(React.useCallback(function(){n.current=r()},[r])),l=u[0],s=u[1];return React.useLayoutEffect(function(){if(t){var e=i();return e.addEventListener("focus",l),e.addEventListener("blur",s),isInputFocused(e)&&l(),function(){e.removeEventListener("focus",l),e.removeEventListener("blur",s),s()}}}),{getSelection:r,getLastSelection:a,setSelection:o}}function useValue(e,t){var n=useInputElement(e),i=React.useRef(t);return{getValue:React.useCallback(function(){return n().value},[n]),getLastValue:React.useCallback(function(){return i.current},[]),setValue:React.useCallback(function(e){i.current=e;var t=n();t&&(t.value=e)},[n])}}function useInputState(e,t){var n=React.useRef(),i=useSelection(n,t),r=i.getSelection,a=i.getLastSelection,o=i.setSelection,u=useValue(n,e),l=u.getValue,s=u.getLastValue,c=u.setValue;return{inputRef:n,getInputState:function(){return{value:l(),selection:r()}},getLastInputState:function(){return{value:s(),selection:a()}},setInputState:function(e){var t=e.value,n=e.selection;c(t),o(n)}}}function usePrevious(e){var t=React.useRef();return React.useEffect(function(){t.current=e}),t.current}require("warning");var CONTROLLED_PROPS=["disabled","onBlur","onChange","onFocus","onMouseDown","readOnly","value"],defaultFormatChars={9:/[0-9]/,a:/[A-Za-z]/,"*":/[A-Za-z0-9]/};function validateMaskPlaceholder(e){var t=e.mask,n=e.maskPlaceholder;t&&n&&1!==n.length&&n.length!==t.length&&invariant(!1)}function validateChildren(e,t){CONTROLLED_PROPS.filter(function(n){return null!=t.props[n]&&t.props[n]!==e[n]}).length&&invariant(!1)}function isFunction(e){return"function"==typeof e}function findLastIndex(e,t){for(var n=e.length-1;n>=0;n--){if(t(e[n],n))return n}return-1}function repeat(e,t){void 0===t&&(t=1);for(var n="",i=0;i<t;i++)n+=e;return n}function toString(e){return""+e}function parseMask(e){var t=e.mask,n=e.maskPlaceholder,i=[];if(!t)return{maskPlaceholder:null,mask:null,prefix:null,lastEditablePosition:null,permanents:[]};if("string"==typeof t){var r=!1,a="";t.split("").forEach(function(e){r||"\\"!==e?(!r&&defaultFormatChars[e]||i.push(a.length),a+=e,r=!1):r=!0}),t=a.split("").map(function(e,t){return-1===i.indexOf(t)?defaultFormatChars[e]:e})}else t.forEach(function(e,t){"string"==typeof e&&i.push(t)});n&&(n=1===n.length?t.map(function(e,t){return-1!==i.indexOf(t)?e:n}):n.split(""),i.forEach(function(e){n[e]=t[e]}),n=n.join(""));for(var o=i.filter(function(e,t){return e===t}).map(function(e){return t[e]}).join(""),u=t.length-1;-1!==i.indexOf(u);)u--;return{maskPlaceholder:n,prefix:o,mask:t,lastEditablePosition:u,permanents:i}}var MaskUtils=function(e){var t=this;this.isCharacterAllowedAtPosition=function(e,n){var i=t.maskOptions.maskPlaceholder;return!!t.isCharacterFillingPosition(e,n)||!!i&&i[n]===e},this.isCharacterFillingPosition=function(e,n){var i=t.maskOptions.mask;if(!e||n>=i.length)return!1;if(!t.isPositionEditable(n))return i[n]===e;var r=i[n];return new RegExp(r).test(e)},this.isPositionEditable=function(e){var n=t.maskOptions,i=n.mask,r=n.permanents;return e<i.length&&-1===r.indexOf(e)},this.isValueEmpty=function(e){return e.split("").every(function(e,n){return!t.isPositionEditable(n)||!t.isCharacterFillingPosition(e,n)})},this.isValueFilled=function(e){return t.getFilledLength(e)===t.maskOptions.lastEditablePosition+1},this.getDefaultSelectionForValue=function(e){var n=t.getFilledLength(e),i=t.getRightEditablePosition(n);return{start:i,end:i}},this.getFilledLength=function(e){return findLastIndex(e.split(""),function(e,n){return t.isPositionEditable(n)&&t.isCharacterFillingPosition(e,n)})+1},this.getStringFillingLengthAtPosition=function(e,n){return e.split("").reduce(function(e,n){return t.insertCharacterAtPosition(e,n,e.length)},repeat(" ",n)).length-n},this.getLeftEditablePosition=function(e){for(var n=e;n>=0;n--)if(t.isPositionEditable(n))return n;return null},this.getRightEditablePosition=function(e){for(var n=t.maskOptions.mask,i=e;i<n.length;i++)if(t.isPositionEditable(i))return i;return null},this.formatValue=function(e){var n=t.maskOptions,i=n.maskPlaceholder,r=n.mask;if(!i){for(e=t.insertStringAtPosition("",e,0);e.length<r.length&&!t.isPositionEditable(e.length);)e+=r[e.length];return e}return t.insertStringAtPosition(i,e,0)},this.clearRange=function(e,n,i){if(!i)return e;var r=n+i,a=t.maskOptions,o=a.maskPlaceholder,u=a.mask,l=e.split("").map(function(e,i){var a=t.isPositionEditable(i);return!o&&i>=r&&!a?"":i<n||i>=r?e:a?o?o[i]:"":u[i]}).join("");return t.formatValue(l)},this.insertCharacterAtPosition=function(e,n,i){var r=t.maskOptions,a=r.mask,o=r.maskPlaceholder;if(i>=a.length)return e;var u=t.isCharacterAllowedAtPosition(n,i),l=t.isPositionEditable(i),s=t.getRightEditablePosition(i),c=o&&s?n===o[s]:null,f=e.slice(0,i);!u&&l||(e=f+(u?n:a[i]));return u||l||c||(e=t.insertCharacterAtPosition(e,n,i+1)),e},this.insertStringAtPosition=function(e,n,i){var r=t.maskOptions,a=r.mask,o=r.maskPlaceholder;if(!n||i>=a.length)return e;var u=n.split(""),l=t.isValueFilled(e)||!!o,s=e.slice(i);if(e=u.reduce(function(e,n){return t.insertCharacterAtPosition(e,n,e.length)},e.slice(0,i)),l)e+=s.slice(e.length-i);else if(t.isValueFilled(e))e+=a.slice(e.length).join("");else{e=s.split("").filter(function(e,n){return t.isPositionEditable(i+n)}).reduce(function(e,n){var i=t.getRightEditablePosition(e.length);return null===i?e:(t.isPositionEditable(e.length)||(e+=a.slice(e.length,i).join("")),t.insertCharacterAtPosition(e,n,e.length))},e)}return e},this.processChange=function(e,n){var i=t.maskOptions,r=i.mask,a=i.prefix,o=i.lastEditablePosition,u=e.value,l=e.selection,s=n.value,c=n.selection,f=u,d="",h=0,p=0,g=Math.min(c.start,l.start);if(l.end>c.start?(d=f.slice(c.start,l.end),p=(h=t.getStringFillingLengthAtPosition(d,g))?c.length:0):f.length<s.length&&(p=s.length-f.length),f=s,p){if(1===p&&!c.length)g=c.start===l.start?t.getRightEditablePosition(l.start):t.getLeftEditablePosition(l.start);f=t.clearRange(f,g,p)}return f=t.insertStringAtPosition(f,d,g),(g+=h)>=r.length?g=r.length:g<a.length&&!h?g=a.length:g>=a.length&&g<o&&h&&(g=t.getRightEditablePosition(g)),{value:f=t.formatValue(f),enteredString:d,selection:{start:g,end:g}}},this.maskOptions=parseMask(e)},InputMaskChildrenWrapper=function(e){function t(){return e.apply(this,arguments)||this}return _inheritsLoose(t,e),t.prototype.render=function(){var e=this.props,t=e.children,n=_objectWithoutPropertiesLoose(e,["children"]);return React__default.cloneElement(t,n)},t}(React__default.Component),InputMask=React.forwardRef(function(e,t){var n=e.alwaysShowMask,i=e.children,r=e.mask,a=e.maskPlaceholder,o=e.beforeMaskedStateChange,u=_objectWithoutPropertiesLoose(e,["alwaysShowMask","children","mask","maskPlaceholder","beforeMaskedStateChange"]);validateMaskPlaceholder(e);var l=new MaskUtils({mask:r,maskPlaceholder:a}),s=!!r,c=!u.disabled&&!u.readOnly,f=null!==e.value&&void 0!==e.value,d=usePrevious(s),h=useInputState(toString((f?e.value:e.defaultValue)||""),s),p=h.inputRef,g=h.getInputState,v=h.setInputState,m=h.getLastInputState,P=useInputElement(p);if(s&&f){var k=P(),b=k&&isInputFocused(k)||n||e.value?l.formatValue(e.value):e.value;o&&(b=o({nextState:{value:b,selection:{start:null,end:null}}}).value),v(_extends({},m(),{value:b}))}var E=m(),S=E.selection,R=E.value;React.useLayoutEffect(function(){if(s){var e=isInputFocused(P()),t=S,i=g(),r=_extends({},i);if(!f){var a=i.value,u=l.formatValue(a),c=l.isValueEmpty(u);!c||e||n?r.value=u:c&&!e&&(r.value="")}e&&!d?r.selection=l.getDefaultSelectionForValue(r.value):f&&e&&t&&null!==t.start&&null!==t.end&&(r.selection=t),o&&(r=o({currentState:i,nextState:r})),v(r)}});var C=_extends({},u,{onFocus:function(t){p.current=t.target;var n=g().value;if(s&&!l.isValueFilled(n)){var i=l.formatValue(n),r=l.getDefaultSelectionForValue(i),a={value:i,selection:r};o&&(i=(a=o({currentState:g(),nextState:a})).value,r=a.selection),v(a),i!==n&&e.onChange&&e.onChange(t),defer(function(){v(m())})}e.onFocus&&e.onFocus(t)},onBlur:function(t){var i=g().value,r=m().value;if(s&&!n&&l.isValueEmpty(r)){var a="",u={value:a,selection:{start:null,end:null}};o&&(a=(u=o({currentState:g(),nextState:u})).value),v(u),a!==i&&e.onChange&&e.onChange(t)}e.onBlur&&e.onBlur(t)},onChange:s&&c?function(t){var n=g(),i=m(),r=l.processChange(n,i);o&&(r=o({currentState:n,previousState:i,nextState:r})),v(r),e.onChange&&e.onChange(t)}:e.onChange,onMouseDown:s&&c?function(t){var n=P(),i=g().value;if(!isInputFocused(n)&&!l.isValueFilled(i)){var r=t.clientX,a=t.clientY,o=(new Date).getTime();document.addEventListener("mouseup",function e(t){if(document.removeEventListener("mouseup",e),isInputFocused(n)){var i=Math.abs(t.clientX-r),u=Math.abs(t.clientY-a),s=Math.max(i,u),c=(new Date).getTime()-o;if(s<=10&&c<=200||s<=5&&c<=300){var f=m(),d=_extends({},f,{selection:l.getDefaultSelectionForValue(f.value)});v(d)}}})}e.onMouseDown&&e.onMouseDown(t)}:e.onMouseDown,ref:function(e){p.current=reactDom.findDOMNode(e),isFunction(t)?t(e):null!==t&&"object"==typeof t&&(t.current=e)},value:s&&f?R:e.value});return i?(validateChildren(e,i),React__default.createElement(InputMaskChildrenWrapper,C,i)):React__default.createElement("input",C)});InputMask.displayName="InputMask",InputMask.defaultProps={alwaysShowMask:!1,maskPlaceholder:"_"},module.exports=InputMask;
